/* hosts.allow rule injector, will sit on a port (defaults to 4444)
 * when hip gets a connection, it will ask for a key, when the
 * correct key is given, hip will add the connectors numeric ip
 * address to /etc/hosts.allow and disconnect. hip will fork off
 * as seperate connections come in.
 * 
 * 
 * telnetd@unix9.org
 */
#include <stdio.h>
#include <unistd.h>
#include <time.h>
#include <stdlib.h>
#include <errno.h>
#include <string.h>
#include <sys/types.h>
#include <netinet/in.h>
#include <sys/socket.h>
#include <sys/wait.h>
#include <signal.h>
#define mx 500
#define port 4444
char	receive1[];
FILE * hostallow;

int
main(int argc, char **argv)
{
	int             socket1;
	int             sock1;
	int             sin_size;
	struct sockaddr_in my_addr;
	struct sockaddr_in their_addr;
	my_addr.sin_port = htons(port);
	if ((socket1 = socket(AF_INET, SOCK_STREAM, 0)) == -1) {
		perror("socket");
		exit(1);
	}
	my_addr.sin_family = AF_INET;
	my_addr.sin_addr.s_addr = INADDR_ANY;

	bzero(&(my_addr.sin_zero), 8);

	if (bind(socket1, (struct sockaddr *) & my_addr, sizeof(struct sockaddr)) == -1) {
		perror("bind");
		exit(1);
	}
	if (listen(socket1, 25) == -1) {
		perror("listen");
		exit(1);
	}
	if (!fork())
		while (1) {
			sin_size = sizeof(struct sockaddr_in);
			if ((sock1 = accept(socket1, (struct sockaddr *) & their_addr, &sin_size)) == -1) {
				perror("accept");
				continue;
			}
			/* executed/while after a connection */
			if(!fork()) {
				send(sock1, "Key: ", 5, 0);
				recv(sock1, receive1, 5, 0);

				if(receive1[0] == '\r') {
					send(sock1, "Must enter key.\r\n\r", 17, 0);
					close(sock1);
					exit(0);
				}
	if(!strcmp(receive1, "91991")) {
	hostallow = fopen("hosts.allow", "a+");
	fprintf(hostallow, "ALL : ", mx);
	fprintf(hostallow, "%s\n", inet_ntoa(their_addr.sin_addr), mx);
	fclose(hostallow);
	send(sock1, "Key Correct. Host added.\r\n\r", 26, 0);
	exit(0);
				} else {
					send(sock1, "Key incorrect.\r\n\r", 16, 0);
					close(sock1);
					exit(1);
				}

				close(sock1);
				exit(0);


			}
			close(sock1);
			while (waitpid(-1, NULL, WNOHANG) > 0);
		}
}
