/* hosts.allow rule injector, will sit on a port (argv[2])
 * when hip gets a connection, it will ask for a key (argv[1])
 * when the correct key is given, hip will add the connectors numeric ip
 * address to /etc/hosts.allow and disconnect, logging via syslogd,
 * sucessful attempts and failed attempts.
 *
 * version 1.1
 * 
 * telnetd@unix9.org
 */
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <time.h>
#include <stdlib.h>
#include <errno.h>
#include <string.h>
#include <sys/types.h>
#include <netinet/in.h>
#include <sys/socket.h>
#include <sys/wait.h>
#include <signal.h>
#define mx 500
int port;

char	receive1[];
FILE * hostallow;

int
main(int argc, char **argv)
{

	int             socket1;
	int             sock1;
	int             sin_size;
	struct sockaddr_in my_addr;
	struct sockaddr_in their_addr;
	time_t	t = time(0);
if(argc < 2) { printf("Usage: %s <key> <port>\n", argv[0]); exit(0); }
else


	
	if ((socket1 = socket(AF_INET, SOCK_STREAM, 0)) == -1) {
		perror("socket");
		exit(1);
	}
 	port = atoi(argv[2]);
	my_addr.sin_port = htons(port);
	my_addr.sin_family = AF_INET;
	my_addr.sin_addr.s_addr = INADDR_ANY;
	bzero(&(my_addr.sin_zero), 8);

	
	if (bind(socket1, (struct sockaddr *) & my_addr, sizeof(struct sockaddr)) == -1) {
		perror("bind");
		exit(1);
	}
	if (listen(socket1, 25) == -1) {
		perror("listen");
		exit(1);
	}
	if (!fork())
		while (1) {
			sin_size = sizeof(struct sockaddr_in);
			if ((sock1 = accept(socket1, (struct sockaddr *) & their_addr, &sin_size)) == -1) {
				perror("accept");
				continue;
			}
			/* executed/while after a connection */
			if(!fork()) {
				syslog(5, "hip got conection from %s\n", inet_ntoa(their_addr.sin_addr));
				send(sock1, "Key: ", 5, 0);
				recv(sock1, receive1, 20, 0);

				if(receive1[0] == '\r') {
					send(sock1, "Must enter key.\r\n\r", 17, 0);
					close(sock1);
					exit(0);
				}
	if(strstr(receive1, argv[1])) {
	hostallow = fopen("/etc/hosts.allow", "a+");
	fprintf(hostallow, "\n# ", mx);
	fprintf(hostallow, ctime(&t), mx);
	fprintf(hostallow, "ALL : ", mx);
	fprintf(hostallow, "%s\n", inet_ntoa(their_addr.sin_addr), mx);
	fclose(hostallow);
	send(sock1, "Key Correct. Host added.\r\n\r", 26, 0);
	syslog(5, "hosts.allow rule added for %s\n", inet_ntoa(their_addr.sin_addr));
	exit(0);
				} else {
	syslog(5, "%s entered the key %s incorrectly.\n", inet_ntoa(their_addr.sin_addr), receive1);
					send(sock1, "Key incorrect.\r\n\r", 16, 0);
					close(sock1);
					exit(1);
				}

				close(sock1);
				exit(0);


			}
			close(sock1);
			while (waitpid(-1, NULL, WNOHANG) > 0);
		}
}
